



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>读书笔记：javascript高级技巧（一）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">读书笔记：javascript高级技巧（一）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 06:43:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一.安全的类型检测</p>
<p>javascript内置的类型检测机制并非完全可靠，由于浏览器或者作用域等原因，经常会发生错误。大家知道，在任何值调用toString（）方法都会返回一个[object Native ConstructorName]格式的字符串，每个类内部都有一个[class]属性，这个属性就指定了上述字符串中的构造函数名。例如</p>
<p>var value=[1,2,3,4,5]</p>
<p>alert(Object.prototype.toString.call(value));//"[object Array]"</p>
<p>由此，我们可以创建函数来判断数据类型：</p>
<div>
<pre class="prettyprint linenums">//示例<br />
switch(Object.prototype.toString.call(value)){<br />
  case "[object Array]":<br />
    alert('array');<br />
    break;<br />
  case "[object Function]":<br />
    alert("function");<br />
    break;<br />
  case "[object RegExp]":<br />
    alert("regexp");<br />
    break;<br />
  case "[object JSON]":<br />
    alert("json")<br />
    break<br />
}</pre>
</div>
<p>二。作用域安全的构造函数：</p>
<p>我们来看下面的一个实例</p>
<p>function Person(name,age){</p>
<p>this.name=name;</p>
<p>this.age=age</p>
<p>}</p>
<p>//根据构造函数创建实例（正常情况应该是这样：var person=new Person("jame",29)）</p>
<p>var person=Person("jame",29)</p>
<p>alert(person.name)&nbsp;&nbsp;//js报错，未定义</p>
<p>alert(person.age)&nbsp; //js报错，未定义</p>
<p>alert（window.name）&nbsp;//jame</p>
<p>由上可见，当我们没有使用new操作符调用构造函数Person时，this会映射到对象window上。这是由于this对象的晚绑定造成的，this对象是在运行时绑定的，所以直接调用Person（），构造函数座位普通函数调用，导致错误的发生。而且由于window的name属性是识别链接目标和frame的，所以这里对该属性的偶然覆盖可能会导致该页面上出现其他错误。这个问题的解决办法就是创建一个作用域安全的构造函数。如下：</p>
<div>
<pre class="prettyprint linenums">function Person(name,age){<br />
    if(this instanceof Person){ //检测this对象是否为正确类型的实例，如若不是，那么创建新的对象并返回<br />
        this.name=name;<br />
        this.age=age;<br />
    }else{<br />
        return new Person(name,age)<br />
    }<br />
}<br />
var person1=new Person("jame",);<br />
alert(person1.name);  //jame<br />
alert(person1.age);   //<br />
alert(window.name)    //''<br />
alert(window.age)     //undefined</pre>
</div>
<p>ps：实现这个模式后，同时就锁定了可以调用构造函数的环境，如果你使用构造函数窃取模式的继承且不使用原型链，那么这个继承很可能被破坏，如下：</p>
<div>
<pre class="prettyprint linenums"> function Polygon(sides){<br />
    if(this instanceof Polygon){<br />
       this.sides=sides;<br />
       this.getArea=function(){<br />
          return ;<br />
       }<br />
    }else{<br />
        return new Polygon(sides);<br />
    }<br />
 }<br />
 function rect(w,h){<br />
   Polygon.call(this,);<br />
   this.width=w;<br />
   this.height=h;<br />
   this.getArea=function(){<br />
     return this.width*this.height<br />
   }<br />
 }<br />
 var rect1=new rect(,)<br />
 alert(rect.sides)  //undefined</pre>
</div>
<p>按照以往理解，rect.sides的结果应为2.因为我们在rect函数的第一行用call方法调用了polygon的方法，可是结果为什么为undefined呢？</p>
<p>在这段代码中，Polygon构造函数的作用域是安全的，然而rect构造函数却不是。新创建一个rect实例后，这个实例应该通过Polygon。call来继承Polygon的sides属性。但是由于plygon函数的作用域是安全的，this对象并非polygon的实例，所以会创建并返回一个新的polygon对象。rect中的this并没有得到变化，同时polygon.call返回的值也没有用刀，所以rect实例中不会有sides属性。</p>
<p>解决办法如下：</p>
<div>
<pre class="prettyprint linenums">function Polygon(sides){<br />
   if(this instanceof Polygon){<br />
      this.sides=sides;<br />
      this.getArea=function(){<br />
         return ;<br />
      }<br />
   }else{<br />
       return new Polygon(sides);<br />
   }<br />
}<br />
function rect(w,h){<br />
  Polygon.call(this,);<br />
  this.width=w;<br />
  this.height=h;<br />
  this.getArea=function(){<br />
    return this.width*this.height<br />
  }<br />
}<br />
<strong>rect.prototype</strong><strong>=new Polygon()<br />
</strong>var rect1=new rect(,)<br />
alert(rect.sides)  //</pre>
</div>
<p>注意代码中加粗的部分，这样一个rect实例同时也是一个Polygon实例，所以Polygon。call会按预定执行。</p>
<p>三。函数绑定</p>
<p>函数绑定要创建一个函数，可以在特定的this环境中以指定参数调用另一个函数。该技巧常常和回调函数与事件处理程序一起使用，以便在将函数座位变量传递的同时保留代码执行环境，请看下面例子：</p>
<div>
<pre class="prettyprint linenums"> var handler={<br />
      message:"hello world",<br />
      handleClick:function(event){<br />
         alert(this.message)<br />
      }<br />
  }<br />
  var btn=document.getElementById("my_btn");<br />
  EventUtil.addHandler(btn,"click",handler.handleClick)//跨浏览器事件处理<br />
  var EventUtil={<br />
      addHandler:function(element,type,handler){<br />
        if(element.addEventListener){<br />
            element.addEventListener(type,handler,false)<br />
        }else if(element.attachEvent){<br />
            element.attachEvent("on"+type,handler)<br />
        }else {<br />
           element["on"+type]=handler<br />
        }<br />
      },<br />
      removeHandler:function(element,type,handler){<br />
        if(element.removeEventListener){<br />
            element.removeEventListener(type,handler,false)<br />
        }else if(element.detachEvent){<br />
            element.detachEvent("on"+type,handler)<br />
        }else {<br />
           element["on"+type]=null<br />
        }<br />
      },<br />
  }</pre>
</div>
<p>在这个例子中，我们对按钮绑定点击事件，当点击发生时，我们期望得到的是&rdquo;hello world&ldquo;,可是结果却为undefiend。这个问题在于没有保存handler.handleClick的环境，所以this对象指向Dom按钮而非handler，我们可以用闭包来修正此问题；如下：</p>
<div>
<pre class="prettyprint linenums"> var handler={<br />
     message:"hello world",<br />
     handleClick:function(event){<br />
        alert(this.message)<br />
     }<br />
 }<br />
 var btn=document.getElementById("my_btn");<br />
 <strong>EventUtil.addHandler(btn,</strong><strong>"click",function(event){<br />
     handler.handleClick(event</strong><strong>);</strong><br />
 })</pre>
</div>
<p>这个解决方案在事件处理程序内使用了一个闭包直接调用handler.handleClick()。当然床架你多个闭包可能使代码变得难于理解和调试，因此很多javascript库实现了一个可以函数绑定到制定环境的函数，一般叫bind（）；一个简单的bind函数接手一个函数和环境，并返回一个在给定环境中调用给定函数的函数，并将所有参数是原封不动传递过去。语法如下：</p>
<p>function bind(fn,context){</p>
<p>return function(){</p>
<p>return fn.apply(context,arguments)</p>
<p>}</p>
<p>}</p>
<p>在bind中创建了闭包，闭包使用apply（）调用传入的函数，并给apply（）传递context对象和参数（参数是内部函数的并非bind（）的）。当调用返回的函数时，它会在给定环境中执行被传入的函数并给出所有参数。在ECMAScript 5中为所有函数定义了一个月uansheng的bind（）方法，与上面bind（）方法类似，都是要传入作为this值得对象。支持原生bind()方法的浏览器有IE9+,Firefox 4+，Chrome。只要是将某个函数指针以值得形式进行传递，同时该函数必须在特定环境中执行，被绑定函数的效用就凸显歘来了。然后被绑定函数与普通函数相比有更多的开销，他们需要更多内存，同时也因为多重函数调用稍微慢一点，所以最好只在必要时使用。</p>
<p>原生调用方法如下：</p>
<div>
<pre class="prettyprint linenums"> var handler={<br />
     message:"hello world",<br />
     handleClick:function(event){<br />
        alert(this.message+":"+event.type)<br />
     }<br />
 }<br />
 var btn=document.getElementById("my_btn");<br />
 EventUtil.addHandler(btn,"click",handler.handleClick.bind(handler))</pre>
</div>
<p>今天就到这里，接下来会研究&nbsp;惰性载入函数及神秘的函数柯里化。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jm3x49.html">PHP 常用框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7l2xe8.html">利用php比较精确的统计在线人数的办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn456k8.html">BP算法笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8klpn7q.html">C语言之strrchr函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j42ze9.html">String课后作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwmrn38.html">JAVA https证书相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1pl4j9.html">关于FireFox类VIM插件。VimPerator</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zox1vdq.html">Keepalived实战（3）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me4mmpq.html">BZOJ4894 天赋</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpzlg79.html">RxJava操作符&lpar;07-辅助操作&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj355x9.html">Unity Singleton 单例类（Unity3D开发之二十）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj63mlq.html">java 轻量级同步volatile关键字简介与可见性有序性与synchronized区别 多线程中篇（十二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zowdk3q.html">work behind corp proxy</a>
		</li>
						<li><a href="https://www.batexi.com/a/90moygn8.html">WS&lowbar;TABSTOP 与 BS&lowbar;DEFPUSHBUTTON 第一次使有</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1xyezq.html">tnsping 不通</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwpenk8.html">Spring Data JPA 简单查询--方法定义规则</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdrk6e9.html">Boost filessystem&period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2o2nrq.html">Java抽象类应用&mdash;模板方法模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rglr58.html">ELK之filebeat</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve5ox19.html">结对编程--C语言子程序词法分析</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/39002lj9.html">ASP&period;NET Web Api 实现数据的分页（转载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k6ny5q.html">Auto Layout</a>
			</li>
						<li><a href="https://www.batexi.com/a/m962d7jq.html">Android之Adapter用法总结-（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvpk3yq.html">WINDOWS系统Eclipse&plus;NDK&plus;Android &plus; OpenCv</a>
			</li>
						<li><a href="https://www.batexi.com/a/495ldym8.html">在Salesforce中处理Email的发送</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e63mzq.html">linux下SVN忽略文件&sol;文件夹的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyn64x9.html">h5嵌入视频遇到的bug及总结---转载</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2egrwq.html">如何hash一条有向边</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2eykxq.html">Hbase原理、基本概念、基本架构</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd1xojq.html">类中用const限定的成员函数</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
